local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/modem_user.conf"
}

----------------------------
local modem_template = DC.SET(
	DC.OBJ({
		apn = DC.STR(""),
		username = DC.STR(""),
		password = DC.STR(""),
		pin = DC.STR("")
	})
) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
    modem1 = {
		apn = "",
		username = "",
		password = "",
		pin = ""
	},
	modem2 = {
		apn = "",
		username = "",
		password = "",
		pin = ""
	}
}

function _M.Load()
	local conf = CONF.Create({}, modem_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


