local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/netlink.conf"
}

----------------------------
local portfwd_template = DC.OBJ({
    addr = DC.STR(""),
    port = DC.NUM(7000),
    authcode = DC.STR(""),
	timeout = DC.NUM(15),
	polydevs = DC.ARR({
		id = DC.NUM(1),
		ifname = DC.STR("modem1"),
	}),
	poly_enabled = DC.NUM(1),
}) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
    addr = "",
    port = 7000,
    authcode = "",
	timeout = 15,
	polydevs = {
		{ id = 1, ifname = "modem1" },
		{ id = 2, ifname = "modem2" },
	},
	poly_enabled = 0,
}

function _M.Load()
	local conf = CONF.Create({}, portfwd_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


