local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/poly.conf"
}

----------------------------
local poly_template = DC.ARR(
	DC.OBJ({
			id = DC.INT(1),
			ifname = DC.STR("eth0"),
	})
)  : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
    { id = 1, ifname = "wwan0" },
    { id = 2, ifname = "wwan1" },
    { id = 3, ifname = "wwan2" },
}

function _M.Load()
	local conf = CONF.Create({}, poly_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


