--Controller of modem_set
local _M = require( "controller.generic" )()
local nu = require "kiloview.netUtil"
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SaveSet( args )

	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	if not tonumber(args.gsm_pin) or tonumber(args.gsm_pin) <= 999 or tonumber(args.gsm_pin) >= 10000 or tonumber(args.gsm_pin) ~= math.ceil(tonumber(args.gsm_pin)) then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local new = {
		apn = args.gsm_apn,
		username = args.gsm_user,
		password = args.gsm_pass,
		pin = args.gsm_pin
	}
	

	local r, o = _M.MasterCall( "NETWORK_MANAGER.SetModemConfig", args.devname, new )
	if r and o then
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SAVE_DONE .. [["}]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end
end

--------------------------------
_M.AjaxExport ("SaveSet", SaveSet, "json") 
--------------------------------

-- Check the request arguments

function _M.Check()
	local obj, objPath,devname,port
	local newOne = false
	local specConn

	if not cgilua.QUERY or not cgilua.QUERY.obj then
		cgilua.put( "<h2>" .. _M.langs.INVALID_MODEMSET_PARAM .. "</h2>" )
		return nil
	else
		obj = cgilua.QUERY.obj

		-- if cgilua.QUERY.newcon then	--New connection
		-- 	newOne = true
		-- else
		-- 	if cgilua.QUERY.con then --Specified connection (Modify)
		-- 		specConn = cgilua.QUERY.con
		-- 	else
		-- 		cgilua.put( "<h2>" .. _M.langs.INVALID_MODEMCONN_PARAM .. "</h2>" )
		-- 		return nil
		-- 	end
		-- end
	end

	devname = cgilua.QUERY.devname

	local r, devInfo = _M.MasterCall( "NETWORK_MANAGER.GetModemConfig", devname )
	if not r or not devInfo then
		cgilua.put( [[<h2>]] .. _M.langs.GET_DEVINFO_ERROR .. [[<hr class="title_line" /></h2>
						<p>]] .. _M.langs.GET_DEVINFO_ERROR_DETAIL .. [[</p>
						<a href="#" onclick="ShowPage('netlist.lp'); return false;">]] .. _M.langs.RETURN_TO_NETLIST .. [[</a> ]] )
		return nil
	end

	local id = ""
	local netType = "gsm"
	local gsm_apn = ""
	local gsm_user = ""
	local gsm_pass = ""
	local gsm_number = "*#99#"
	local gsm_pin = ""
	local cdma_user = ""
	local cdma_pass = ""
	local cdma_number = "#777"
	local autoconn = true
	local uuid = ""
	local only4G = "no"

	if newOne then	--Get AP information, and put to parameters.
		--NM_DEVICE_MODEM_CAPABILITY_CDMA_EVDO: 0x2
		--remotedostring( "print(...)", devInfo.MODEM, devInfo.MODEM.CurrentCapabilities )
		if devInfo.MODEM.CurrentCapabilities:match("CDMA") then
			netType = "cdma"
		--else is default 'gsm'
		end
	elseif specConn then	--Modify the connection
		
	end
	
	return {
		obj = obj,
		objPath = objPath,
		newOne = newOne,
		specConn = specConn,
		id = id,
		netType = netType,
		gsm_apn = devInfo.apn,
		gsm_user = devInfo.username,
		gsm_pass = devInfo.password,
		gsm_number = gsm_number,
		gsm_pin = devInfo.pin,
		cdma_user = cdma_user,
		cdma_pass = cdma_pass,
		cdma_number = cdma_number,
		autoconn = autoconn,
		uuid = uuid,
		devname = devname,
		port = port,
		only4G = only4G,
	}
	
end

function _M.getRevision(devname)
	local r, modemInfo = _M.MasterCall( "NETWORK_MANAGER.GetModemInfo", devname)
	if not r or not modemInfo then
		return nil
	end
	local revision
	if modemInfo and modemInfo["ModemInfo"] and modemInfo["ModemInfo"]["Revision"] then
		revision = modemInfo["ModemInfo"]["Revision"]
	else
		revision = nil
	end
	return revision	
end

function _M.GetModemStatus(devname)
	local is_ok, r = _M.MasterCall( "NETWORK_MANAGER.GetModemStatus", devname)
	if not is_ok then
		return {}
	end
	return r
end
--------------------------------

return _M

